<?php

use Workerman\Protocols\Http;

class base {
	var $db;
	var $time;
	var $view;
	var $user = array();
	var $lang = array();
	var $input = array();

	function __construct() {
		$this->time = time();
		$this->init_db();
		$this->init_user();
		$this->init_input();
		$this->init_template();
		
		$this->view->assign('user', $this->user);
	}

	function init_input() {
		if($_REQUEST){
			$this->input = $_REQUEST;
		}
	}
	
	function init_db() {
		global $db;
		$this->db = $db;
	}
	
	function init_user() {
		if(isset($_COOKIE[ADMIN_COOKIES_NAME])){
			$this->user['username'] = $_COOKIE[ADMIN_COOKIES_NAME] ? $_COOKIE[ADMIN_COOKIES_NAME] : '';
		}else{
			$this->user['username'] = '';
		}
	}
	
	function init_template() {
		require_once API_ROOT.'lib/template.class.php';
		$this->view = new template();
		$this->view->assign('user', $this->user);
	}
	
	function isAdmin(){
		if(!$this->user['username']){
			return Http::header('location: admin.php?m=user&a=login');
		}else{
			return true;
		}
	}
	
	function isAjaxSubmit(){
		if(isset($_SERVER['HTTP_X_REQUESTED_WITH']) ) {
			if('xmlhttprequest' == strtolower($_SERVER['HTTP_X_REQUESTED_WITH']))
				return true;
		}
		return false;
	}
	
	function isPostSubmit(){
		return $_SERVER['REQUEST_METHOD'] == 'POST' ? true : false;
	}
	
}

?>