<?php

use \GatewayWorker\Lib\Gateway;

class imcontrol extends base {
	
	function __construct() {
		parent::__construct();
	}
	
	function onready(){
		$domain = $this->input['domain'];
		$ids = $this->input['ids'] ? explode(',', $this->input['ids']) : array();
		$uid = intval($this->input['uid']);
		$type = in_array($this->input['type'], array('friend', 'group')) ? $this->input['type'] : 'friend';
		if(!$domain || !$ids || !$uid) return;
		
		$data = array();
		foreach($ids as $v){
			$data['online'][$v] = Gateway::isUidOnline($domain.'_'.$v) ? 1 : 0;
		}
		arsort($data['online']);
		$data['offline'] = $this->_get_offlinemessage($domain, $uid, -1, $type);
		
		return $data;
	}
	
	function onmembers(){
		$isall = $this->input['isall'];
		$domain = $this->input['domain'];
		$id = intval($this->input['id']);
		if(!$domain || !$id) return;
		
		$temp = Gateway::getClientSessionsByGroup($isall ? '' : $domain.'_'.$id);
		foreach($temp as $k => $v){
			$data[$v['id']] = $v;
		}
		
		if(isset($this->input['page']))
		{
			$perpage = 10;
			$page = $this->input['page'] ? intval($this->input['page']) : 1;
			if($page < 1) $page = 1;
			
			$total = count($data);
			$data = page_array($perpage, $page, $data, 0);
			$pages = ceil($total / $perpage);
			
			return array('total' => $total, 'pages' => $pages, 'data' => $data);
		}else{
			return $data;
		}
	}
	
	function ononline(){
		$domain = $this->input['domain'];
		$ids = $this->input['ids'] ? explode(',', $this->input['ids']) : array();
		if(!$domain || !$ids) return;
		
		$data = array();
		foreach($ids as $v){
			$data[$v] = Gateway::isUidOnline($domain.'_'.$v) ? 1 : 0;
		}
		arsort($data);
		
		return $data;
	}
	
	function onofflinemessage(){
		$domain = $this->input['domain'];
		$id = intval($this->input['id']);
		$uid = intval($this->input['uid']);
		$type = in_array($this->input['type'], array('friend', 'group')) ? $this->input['type'] : 'friend';
		if(!$domain || !$uid) return;
		
		return $this->_get_offlinemessage($domain, $uid, $id, $type);
	}
	
	function onhistorymessage(){
		$domain = $this->input['domain'];
		$id = intval($this->input['id']);
		$uid = intval($this->input['uid']);
		$type = in_array($this->input['type'], array('friend', 'group')) ? $this->input['type'] : 'friend';
		$perpage = intval($this->input['perpage']);
		$page = $this->input['page'] ? intval($this->input['page']) : 1;
		if(!$domain || !$id || !$uid) return;
		
		if($page < 1) $page = 1;
		$perpage = $perpage ? $perpage : 10;
		$start = ($page - 1) * $perpage;
		
		$limit = '';
		if ($start > 0 && $perpage > 0) {
			$limit = " LIMIT $start, $perpage";
		}elseif ($perpage) {
			$limit =  " LIMIT $perpage";
		}elseif ($start) {
			$limit =  " LIMIT $start";
		}
		
		$where = " WHERE domain = '$domain' ";
		$where .= $type == 'friend' ? " AND ((uid = $uid AND fuid = $id) OR (uid = $id AND fuid = $uid)) " : " AND fuid = $id AND type = 'group' ";
		$total = $this->db->single("SELECT COUNT(*) FROM ".TABLE_PRE."heart_im_msg $where");
		$temp = $this->db->query("SELECT type,uid,fuid,msg,time FROM ".TABLE_PRE."heart_im_msg $where ORDER BY time ASC $limit");
		$data = array(
			'total' => $total,
			'data' => $temp,
		);
		
		return $data;
	}
	
	function onmoney(){
		$domain = $this->input['domain'];
		$toid = intval($this->input['toid']);
		$uid = intval($this->input['uid']);
		$type = in_array($this->input['type'], array('friend', 'group')) ? $this->input['type'] : 'friend';
		$username = $this->input['username'];
		$avatar = $this->input['avatar'];
		$time = time();
		$mtype = 0;
		
		$data = array();
		$data['code'] = -1;
		if(!$domain || !$toid || !$uid || !$username || !$avatar) return $data;
		
		$mid = moneybagid();
		$send_toid = $domain.'_'.$toid;
		$moneyformat = "money({$mid})[/source/plugin/heart_im/img/money_{$type}.png]";
		
		$status = $type == 'friend' ? (Gateway::isUidOnline($toid) ? 1 : 0) : 1;
		$msgid = $this->db->query("INSERT INTO ".TABLE_PRE."heart_im_msg (type,uid,fuid,domain,msg,time,status) VALUES ('$type',$uid,$toid,'$domain','$moneyformat',$time,$status)");
		
		$send_data = array(
			'message_type' => 'chatMessage',
			'sendid' => $uid,
			'type' => $mtype,
			'data' => array(
				'msgid' => $msgid,
				'username' => $username,
				'avatar' => $avatar,
				'id' => $type == 'friend' ? $uid : $toid,
				'type' => $type,
				'content' => $moneyformat,
				'timestamp'=> $time * 1000,
			)
		);
		if($type == 'friend'){
			Gateway::sendToUid($send_toid, json_encode($send_data));
		}elseif($type == 'group'){
			Gateway::sendToGroup($send_toid, json_encode($send_data));
		}
		$data['code'] = 1;
		$data['mid'] = $mid;
		
		return $data;
	}
	
	function _get_offlinemessage($domain, $uid, $id, $type){
		$where = " WHERE domain = '$domain' AND status = 0 ";
		$where .= $type == 'friend' ? " AND fuid = '$uid' AND type = 'friend'" : " AND fuid = '$id' AND type = 'group' ";
		$data = $this->db->query("SELECT id,uid,msg,time FROM ".TABLE_PRE."heart_im_msg $where ORDER BY time ASC LIMIT 1000");
		if($data){
			$ids = array();
			foreach($data as $k => $v){
				$ids[] = $v['id'];
			}
			$ids = implode(',', $ids);
			$this->db->query("UPDATE ".TABLE_PRE."heart_im_msg SET status = 1 WHERE id IN($ids)");
		}
		return $data;
	}
}