<?php
require_once __DIR__ . '/config.php';

function str_addslashes($string, $force = 0, $strip = FALSE) {
	if(!MAGIC_QUOTES_GPC || $force) {
		if(is_array($string)) {
			foreach($string as $key => $val) {
				$string[$key] = str_addslashes($val, $force, $strip);
			}
		} else {
			$string = addslashes($strip ? stripslashes($string) : $string);
		}
	}
	return $string;
}

function filter_str($value){
	$value = filter_script($value);
	$value = filter_html($value);
	return $value;
}

function filter_script($value) {
	if (is_array($value)) {
		foreach ($value as $k => $v) {
			$value[$k] = filter_script($v);
		}
		return $value;
	} else {
		$parten = array(
			"/(javascript:)?on(click|load|key|mouse|error|abort|move|unload|change|dblclick|move|reset|resize|submit)/i",
			"/<script(.*?)>(.*?)<\/script>/si",
			"/<iframe(.*?)>(.*?)<\/iframe>/si",
			"/<object.+<\/object>/isU"
		);
		$replace = array("\\2", "", "", "");
		$value = preg_replace($parten, $replace, $value, -1, $count);
		if ($count > 0) {
			$value = filter_script($value);
		}
		return $value;
	}
}

function filter_html($value) {
	if (function_exists('htmlspecialchars')) return htmlspecialchars($value);
	return str_replace(array("&", '"', "'", "<", ">"), array("&amp;", "&quot;", "&#039;", "&lt;", "&gt;"), $value);
}